' Conversor

#include "file.bi"
#include "fbpng.bi"
#include "fbgfx.bi"
#include once "crt.bi"

#define RGBA_R( c ) ( CUInt( c ) Shr 16 And 255 )
#define RGBA_G( c ) ( CUInt( c ) Shr  8 And 255 )
#define RGBA_B( c ) ( CUInt( c )        And 255 )
#define RGBA_A( c ) ( CUInt( c ) Shr 24         )

Dim Shared As Integer cnvPal (16)
Dim As Integer fout, i, xs, ys, x, y, c, nsprites, w, h, r, g, b
Dim As uByte orgPalEntry, p1, p2
Dim As Any Ptr img

Sub usage
	Print "radspr in.png out.h palette"
	Print
	Print "where"
	Print "in.png is the file with the 8x8 pixel sprites."
	Print "out.h is the output file."
	Print "palette is a 32 chars string with the 16 palette definitions, in hex."
End Sub

Function convertPixel (clr As Integer) as uByte
	Dim As Integer curDif	' Difference average
	Dim As Integer i
	Dim As Integer rDif, gDif, bDif, avgDif
	Dim As uByte res
	
	curDif = &HFF: res = -1
	
	' Will find the most simmilar colour in palette 
	For i = 0 To 15
		rDif = Abs (RGBA_R (clr) - RGBA_R (cnvPal (i)))
		gDif = Abs (RGBA_G (clr) - RGBA_G (cnvPal (i)))
		bDif = Abs (RGBA_B (clr) - RGBA_B (cnvPal (i)))
		
		avgDif = (rDif + gDif + bDif) / 3
		
		If avgDif <= curDif Then
			curDif = avgDif
			res = i
		End If
	Next i
	
	'Puts ("in " & clr & ", out " & cnvPal (res))
	Return res
End Function

If Len (Command (3)) <> 32 Then
	usage
	System
End If

' First we convert the palette
For i = 0 To 15
	' Palette format is RRRGGGBB
	orgPalEntry = Val ("&H" & Mid (Command (3), 1 + (i * 2), 2))

	' Extract & convert R
	r = (orgPalEntry And &HE0)
	
	' Extract & convert G
	g = (orgPalEntry And &H1C) Shl 3
	
	' Extract & convert B
	b = ((orgPalEntry And &H03) Shl 6)
	
	' Store
	cnvPal (i) = RGB (r, g, b)
	
	'? hex (orgPalEntry, 2) & " => " & hex (c,8)
Next i

screenres 640, 480, 32, , -1

img = png_load (Command (1))

if ImageInfo (img, w, h, , , , ) then
   'Error!
End If

nsprites = (w \ 8) * (h \ 8)
Puts ("Converting " & nsprites & " sprites.")

fout = FreeFile
Open Command (2) For Output As #fout
Print #fout, "#asm"
Print #fout, " "

' Process image
For ys = 0 To (w \ 8) - 1
	For xs = 0 To (h \ 8) - 1
		Print #fout, "._sprite_" & (xs + ys * (w \ 8))		
		For y = 0 to 7
			Print #fout, "    defb ";
			For x = 0 to 7 Step 2
				' Get & convert first pixel to a value 0-15
				p1 = convertPixel (Point (xs * 8 + x, ys * 8 + y, img))
			
				' Get & convert second pixel to a value 0-15
				p2 = convertPixel (Point (xs * 8 + x + 1, ys * 8 + y, img))
				
				' Combine
				Print #fout, "0x" & hex (p1, 1) & hex (p2, 1);
				
				If x < 6 Then Print #fout, ", "; Else Print #fout, " "
			Next x
		Next y
		
		Print #fout, " "
	Next xs
Next ys

Print #fout, "#endasm"
Close #fout

Puts ("DONE!")
